(define (domain logistics)
	(:requirements :typing)
	(:types 
		location 
		package 
		truck plane - vehicle	;;trucks and planes are vehicles
	)
	(:predicates
		(vehicle-at ?t - truck ?at - location)
		(package-at ?p - package ?at - location)
		(package-in ?p - package ?in - vehicle)
		(road ?from ?to - location)				;;for truck
		(corridor ?from ?to - location)			;;for plane
	)
	
	;;we need separate move actions because of the different types of road/corridor
	
	(:action move-truck
		:parameters (?t - truck ?from ?to - location)
		:preconditions (and (vehicle-at ?t ?from) (road ?from ?to))
		:effect (and (not (vehicle-at ?t ?from)) (vehicle-at ?t ?to))
	)
	
	(:action move-plane
		:parameters (?a - plane ?from ?to - location)
		:preconditions (and (vehicle-at ?t ?from) (corridor ?from ?to))
		:effect (and (not (vehicle-at ?t ?from)) (vehicle-at ?t ?to))
	)
	
	;;load/unload can be the same for both vehicles
	
	(:action load
		:parameters (?v - vehicle ?p - package ?where - location)
		:preconditions (and (vehicle-at ?v ?where) (package-at ?p ?where))
		:effect (and (not (package-at ?p ?where)) (package-in ?p ?v))
	)
	
	(:action unload
		:parameters (?v - vehicle ?p - package ?where - location)
		:preconditions (and (vehicle-at ?v ?where) (package-in ?p ?v))
		:effect (and (not (package-at ?p ?where)) (package-at ?p ?where))
	)
)